#include <iostream>
#include <bits/stdc++.h>

using namespace std;
long double h[1000001];
void height(int x)
{
    cout<<setprecision(10)<<h[x]<<endl;
    return;
}
void calcheight(int p,int q,int r,int x)
{
    if(h[x]+r<q)
        return;
    h[x]=q-sqrt(r*r-(x-p)*(x-p));
    return;
}
int main()
{
    long double w,he,r,q;
    cin>>w>>he>>r>>q;
    for(int i=0;i<w;i++)
    {
        h[i]=he;
    }

    for(int i=0;i<q;i++)
    {
        int t;
        cin>>t;
        if(t==2)
        {
            int x;
            cin>>x;
            height(x);
        }
        if(t==1)
        {
            int x,y;
            cin>>x>>y;
            for(int i=y-r;i<y+r&&i<=he;i++)
            calcheight(x,y,r,i);
        }

    }
    return 0;
}